// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	time "time"

	jenkins_io_v1 "github.com/jenkins-x/jx/pkg/apis/jenkins.io/v1"
	versioned "github.com/jenkins-x/jx/pkg/client/clientset/versioned"
	internalinterfaces "github.com/jenkins-x/jx/pkg/client/informers/externalversions/internalinterfaces"
	v1 "github.com/jenkins-x/jx/pkg/client/listers/jenkins.io/v1"
	meta_v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// CommitStatusInformer provides access to a shared informer and lister for
// CommitStatuses.
type CommitStatusInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.CommitStatusLister
}

type commitStatusInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewCommitStatusInformer constructs a new informer for CommitStatus type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewCommitStatusInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredCommitStatusInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredCommitStatusInformer constructs a new informer for CommitStatus type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredCommitStatusInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options meta_v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.JenkinsV1().CommitStatuses(namespace).List(options)
			},
			WatchFunc: func(options meta_v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.JenkinsV1().CommitStatuses(namespace).Watch(options)
			},
		},
		&jenkins_io_v1.CommitStatus{},
		resyncPeriod,
		indexers,
	)
}

func (f *commitStatusInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredCommitStatusInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *commitStatusInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&jenkins_io_v1.CommitStatus{}, f.defaultInformer)
}

func (f *commitStatusInformer) Lister() v1.CommitStatusLister {
	return v1.NewCommitStatusLister(f.Informer().GetIndexer())
}
